
package de.ivu.elect.presentation;

import org.primefaces.event.ToggleEvent;
import org.primefaces.model.menu.MenuModel;

// ELECT-4805, cf. tags/filterPanel.xhtml.
public interface ViewHavingSuchparameterPanel {

  String SUCHPARAMETER_FORM_ID = "frmFilter";

  String SUCHPARAMETER_PANEL_ID = "filterPanel";

  String SUCHPARAMETER_PANEL_CLIENT_ID = SUCHPARAMETER_FORM_ID + ":" + SUCHPARAMETER_PANEL_ID;

  boolean isOptionMenuRendered();

  MenuModel getOptionMenu();

  /*
   * Änderungen an searchParameters -> DynamicFormSearchView!!!
   */

  boolean isSearchParametersRendered();

  boolean isSearchParametersAutofocus();

  boolean isSearchParametersCollapsed();

  boolean isSearchParametersToggleable();

  void onSearchParametersToggled(ToggleEvent event);

  boolean isBtnSearchRendered();

  String getBtnSearchLabel();

  String search();

  boolean isSearchPartialUpdateSupported();

  void searchPartialUpdate();

  void addUpdateOnSearchResultLoaded(String clientId);

  boolean isBtnResetRendered();

  String reset();

  boolean isResetPartialUpdateSupported();

  void resetPartialUpdate();

  boolean isBtnGoBackRendered();

  String goBack();
}
